//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
// Class to manage the overlay scene
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
class OverlayScene{

    DataMesh mesh;
    TwoDimColorbar colorbar;
    Pointer pointer;

    // * * * Constructor * * * //
    OverlayScene(){
	mesh = new DataMesh();
	colorbar = new TwoDimColorbar(mesh.getColormap2D());
	pointer = new Pointer(new Point());   
    }

    // * * * Set the position of the pointer * * * //
    void setLocate(Point point){ pointer.setLocate(point); }

    // * * * Set the selected state of the pointer * * * //
    void setSelected(boolean select){ pointer.setSelected(select); }

    // * * * Draw the overlay scene * * * //
    void drawScene(Picker picker, DataObject object, boolean drawMesh, Point trans, Point rot){
	mesh.drawMesh(object, drawMesh, trans, rot);
	colorbar.drawColorbar();
	picker.start(0);
	pointer.drawPointer(trans, rot);
    }

    // * * * Draw the pointer * * * //
    void drawPointer(Point trans, Point rot){
	pointer.drawPointer(trans, rot);
    }

    // * * * Set the current colorbar point * * * //
    void setCurrentPt(Point locate, Point point) { 
	pointer.setLocate(locate); 
	colorbar.setCurrentPt(point); 
    }

    // * * * Set the colormap data * * * //
    void setColorData(double[] data1, double [] data2, 
		      double min1, double max1, 
		      double min2, double max2, 
		      String label1, String label2){
	mesh.setColorData(data1, data2, min1, max1, min2, max2);
	colorbar.setColormapData((float)min1, (float)max1, (float)min2, (float)max2);
	colorbar.setLabel(label1); colorbar.setLabel2(label2);
    }
}